package org.antlr.tool;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.antlr.analysis.NFAState;
import org.antlr.codegen.CodeGenerator;
import org.antlr.runtime.CommonToken;
import org.antlr.runtime.Token;
import org.antlr.tool.Attribute;
import org.antlr.tool.AttributeScope;
import org.antlr.tool.ErrorManager;
import org.antlr.tool.Grammar;
import org.antlr.tool.GrammarAST;
import org.antlr.tool.RuleLabelScope;

public class Rule {
  public static final boolean supportsLabelOptimization = false;
  
  public String name;
  
  public int index;
  
  public String modifier;
  
  public NFAState startState;
  
  public NFAState stopState;
  
  protected Map<String, Object> options;
  
  public static final Set<String> legalOptions = (Set<String>)new Object();
  
  public GrammarAST tree;
  
  public Grammar grammar;
  
  public GrammarAST argActionAST;
  
  public GrammarAST EORNode;
  
  public AttributeScope returnScope;
  
  public AttributeScope parameterScope;
  
  public AttributeScope ruleScope;
  
  public List<String> useScopes;
  
  public Set<String> throwsSpec;
  
  public LinkedHashMap<String, Grammar.LabelElementPair> tokenLabels;
  
  public LinkedHashMap<String, Grammar.LabelElementPair> wildcardTreeLabels;
  
  public LinkedHashMap<String, Grammar.LabelElementPair> wildcardTreeListLabels;
  
  public LinkedHashMap<String, Grammar.LabelElementPair> charLabels;
  
  public LinkedHashMap<String, Grammar.LabelElementPair> ruleLabels;
  
  public LinkedHashMap<String, Grammar.LabelElementPair> tokenListLabels;
  
  public LinkedHashMap<String, Grammar.LabelElementPair> ruleListLabels;
  
  protected Map<String, Grammar.LabelElementPair> labelNameSpace = new HashMap<String, Grammar.LabelElementPair>();
  
  protected Map<String, Object> actions = new HashMap<String, Object>();
  
  protected List<GrammarAST> inlineActions = new ArrayList<GrammarAST>();
  
  public int numberOfAlts;
  
  protected Map<String, List<GrammarAST>>[] altToTokenRefMap;
  
  protected Map<String, List<GrammarAST>>[] altToRuleRefMap;
  
  public boolean referencedPredefinedRuleAttributes = false;
  
  public boolean isSynPred = false;
  
  public boolean imported = false;
  
  public Rule(Grammar grammar, String ruleName, int ruleIndex, int numberOfAlts) {
    this.name = ruleName;
    this.index = ruleIndex;
    this.numberOfAlts = numberOfAlts;
    this.grammar = grammar;
    this.throwsSpec = new HashSet<String>();
    this.altToTokenRefMap = (Map<String, List<GrammarAST>>[])new Map[numberOfAlts + 1];
    this.altToRuleRefMap = (Map<String, List<GrammarAST>>[])new Map[numberOfAlts + 1];
    for (int alt = 1; alt <= numberOfAlts; alt++) {
      this.altToTokenRefMap[alt] = new HashMap<String, List<GrammarAST>>();
      this.altToRuleRefMap[alt] = new HashMap<String, List<GrammarAST>>();
    } 
  }
  
  public static int getRuleType(String ruleName) {
    if (ruleName == null || ruleName.length() == 0)
      throw new IllegalArgumentException("The specified rule name is not valid."); 
    return Character.isUpperCase(ruleName.charAt(0)) ? 1 : 2;
  }
  
  public void defineLabel(Token label, GrammarAST elementRef, int type) {
    this.grammar.getClass();
    Grammar.LabelElementPair pair = new Grammar.LabelElementPair(this.grammar, label, elementRef);
    pair.type = type;
    this.labelNameSpace.put(label.getText(), pair);
    switch (type) {
      case 2:
        if (this.tokenLabels == null)
          this.tokenLabels = new LinkedHashMap<String, Grammar.LabelElementPair>(); 
        this.tokenLabels.put(label.getText(), pair);
        break;
      case 6:
        if (this.wildcardTreeLabels == null)
          this.wildcardTreeLabels = new LinkedHashMap<String, Grammar.LabelElementPair>(); 
        this.wildcardTreeLabels.put(label.getText(), pair);
        break;
      case 7:
        if (this.wildcardTreeListLabels == null)
          this.wildcardTreeListLabels = new LinkedHashMap<String, Grammar.LabelElementPair>(); 
        this.wildcardTreeListLabels.put(label.getText(), pair);
        break;
      case 1:
        if (this.ruleLabels == null)
          this.ruleLabels = new LinkedHashMap<String, Grammar.LabelElementPair>(); 
        this.ruleLabels.put(label.getText(), pair);
        break;
      case 4:
        if (this.tokenListLabels == null)
          this.tokenListLabels = new LinkedHashMap<String, Grammar.LabelElementPair>(); 
        this.tokenListLabels.put(label.getText(), pair);
        break;
      case 3:
        if (this.ruleListLabels == null)
          this.ruleListLabels = new LinkedHashMap<String, Grammar.LabelElementPair>(); 
        this.ruleListLabels.put(label.getText(), pair);
        break;
      case 5:
        if (this.charLabels == null)
          this.charLabels = new LinkedHashMap<String, Grammar.LabelElementPair>(); 
        this.charLabels.put(label.getText(), pair);
        break;
    } 
  }
  
  public Grammar.LabelElementPair getLabel(String name) {
    return this.labelNameSpace.get(name);
  }
  
  public Grammar.LabelElementPair getTokenLabel(String name) {
    Grammar.LabelElementPair pair = null;
    if (this.tokenLabels != null)
      return this.tokenLabels.get(name); 
    return pair;
  }
  
  public Map<String, Grammar.LabelElementPair> getRuleLabels() {
    return this.ruleLabels;
  }
  
  public Map<String, Grammar.LabelElementPair> getRuleListLabels() {
    return this.ruleListLabels;
  }
  
  public Grammar.LabelElementPair getRuleLabel(String name) {
    Grammar.LabelElementPair pair = null;
    if (this.ruleLabels != null)
      return this.ruleLabels.get(name); 
    return pair;
  }
  
  public Grammar.LabelElementPair getTokenListLabel(String name) {
    Grammar.LabelElementPair pair = null;
    if (this.tokenListLabels != null)
      return this.tokenListLabels.get(name); 
    return pair;
  }
  
  public Grammar.LabelElementPair getRuleListLabel(String name) {
    Grammar.LabelElementPair pair = null;
    if (this.ruleListLabels != null)
      return this.ruleListLabels.get(name); 
    return pair;
  }
  
  public void trackTokenReferenceInAlt(GrammarAST refAST, int outerAltNum) {
    List<GrammarAST> refs = this.altToTokenRefMap[outerAltNum].get(refAST.getText());
    if (refs == null) {
      refs = new ArrayList<GrammarAST>();
      this.altToTokenRefMap[outerAltNum].put(refAST.getText(), refs);
    } 
    refs.add(refAST);
  }
  
  public List<GrammarAST> getTokenRefsInAlt(String ref, int outerAltNum) {
    if (this.altToTokenRefMap[outerAltNum] != null) {
      List<GrammarAST> tokenRefASTs = this.altToTokenRefMap[outerAltNum].get(ref);
      return tokenRefASTs;
    } 
    return null;
  }
  
  public void trackRuleReferenceInAlt(GrammarAST refAST, int outerAltNum) {
    List<GrammarAST> refs = this.altToRuleRefMap[outerAltNum].get(refAST.getText());
    if (refs == null) {
      refs = new ArrayList<GrammarAST>();
      this.altToRuleRefMap[outerAltNum].put(refAST.getText(), refs);
    } 
    refs.add(refAST);
  }
  
  public List<GrammarAST> getRuleRefsInAlt(String ref, int outerAltNum) {
    if (this.altToRuleRefMap[outerAltNum] != null) {
      List<GrammarAST> ruleRefASTs = this.altToRuleRefMap[outerAltNum].get(ref);
      return ruleRefASTs;
    } 
    return null;
  }
  
  public Set<String> getTokenRefsInAlt(int altNum) {
    return this.altToTokenRefMap[altNum].keySet();
  }
  
  public Set<String> getAllTokenRefsInAltsWithRewrites() {
    String output = (String)this.grammar.getOption("output");
    Set<String> tokens = new HashSet<String>();
    if (output == null || !output.equals("AST"))
      return tokens; 
    for (int i = 1; i <= this.numberOfAlts; i++) {
      if (hasRewrite(i)) {
        Map<String, List<GrammarAST>> m = this.altToTokenRefMap[i];
        for (String tokenName : m.keySet()) {
          int ttype = this.grammar.getTokenType(tokenName);
          String label = this.grammar.generator.getTokenTypeAsTargetLabel(ttype);
          tokens.add(label);
        } 
      } 
    } 
    return tokens;
  }
  
  public Set<String> getRuleRefsInAlt(int outerAltNum) {
    return this.altToRuleRefMap[outerAltNum].keySet();
  }
  
  public Set<String> getAllRuleRefsInAltsWithRewrites() {
    Set<String> rules = new HashSet<String>();
    for (int i = 1; i <= this.numberOfAlts; i++) {
      if (hasRewrite(i)) {
        Map<String, ?> m = this.altToRuleRefMap[i];
        rules.addAll(m.keySet());
      } 
    } 
    return rules;
  }
  
  public List<GrammarAST> getInlineActions() {
    return this.inlineActions;
  }
  
  public boolean hasRewrite(int i) {
    GrammarAST blk = this.tree.findFirstType(16);
    GrammarAST alt = blk.getBlockALT(i);
    GrammarAST rew = alt.getNextSibling();
    if (rew != null && rew.getType() == 76)
      return true; 
    if (alt.findFirstType(76) != null)
      return true; 
    return false;
  }
  
  public AttributeScope getAttributeScope(String name) {
    AttributeScope scope = getLocalAttributeScope(name);
    if (scope != null)
      return scope; 
    if (this.ruleScope != null && this.ruleScope.getAttribute(name) != null)
      scope = this.ruleScope; 
    return scope;
  }
  
  public AttributeScope getLocalAttributeScope(String name) {
    AttributeScope scope = null;
    if (this.returnScope != null && this.returnScope.getAttribute(name) != null) {
      scope = this.returnScope;
    } else if (this.parameterScope != null && this.parameterScope.getAttribute(name) != null) {
      scope = this.parameterScope;
    } else {
      AttributeScope rulePropertiesScope = RuleLabelScope.grammarTypeToRulePropertiesScope[this.grammar.type];
      if (rulePropertiesScope.getAttribute(name) != null)
        scope = rulePropertiesScope; 
    } 
    return scope;
  }
  
  public String getElementLabel(String refdSymbol, int outerAltNum, CodeGenerator generator) {
    GrammarAST uniqueRefAST;
    String labelName;
    if (this.grammar.type != 1 && Character.isUpperCase(refdSymbol.charAt(0))) {
      List<GrammarAST> tokenRefs = getTokenRefsInAlt(refdSymbol, outerAltNum);
      uniqueRefAST = tokenRefs.get(0);
    } else {
      List<GrammarAST> ruleRefs = getRuleRefsInAlt(refdSymbol, outerAltNum);
      uniqueRefAST = ruleRefs.get(0);
    } 
    if (uniqueRefAST.code == null)
      return null; 
    String existingLabelName = (String)uniqueRefAST.code.getAttribute("label");
    if (existingLabelName != null) {
      labelName = existingLabelName;
    } else {
      labelName = generator.createUniqueLabel(refdSymbol);
      CommonToken label = new CommonToken(43, labelName);
      if (this.grammar.type != 1 && Character.isUpperCase(refdSymbol.charAt(0))) {
        this.grammar.defineTokenRefLabel(this.name, label, uniqueRefAST);
      } else {
        this.grammar.defineRuleRefLabel(this.name, label, uniqueRefAST);
      } 
      uniqueRefAST.code.add("label", labelName);
    } 
    return labelName;
  }
  
  public boolean getHasMultipleReturnValues() {
    return (this.referencedPredefinedRuleAttributes || this.grammar.buildAST() || this.grammar.buildTemplate() || (this.returnScope != null && this.returnScope.attributes.size() > 1));
  }
  
  public boolean getHasSingleReturnValue() {
    return (!this.referencedPredefinedRuleAttributes && !this.grammar.buildAST() && !this.grammar.buildTemplate() && this.returnScope != null && this.returnScope.attributes.size() == 1);
  }
  
  public boolean getHasReturnValue() {
    return (this.referencedPredefinedRuleAttributes || this.grammar.buildAST() || this.grammar.buildTemplate() || (this.returnScope != null && this.returnScope.attributes.size() > 0));
  }
  
  public String getSingleValueReturnType() {
    if (this.returnScope != null && this.returnScope.attributes.size() == 1)
      return ((Attribute)this.returnScope.attributes.values().iterator().next()).type; 
    return null;
  }
  
  public String getSingleValueReturnName() {
    if (this.returnScope != null && this.returnScope.attributes.size() == 1)
      return ((Attribute)this.returnScope.attributes.values().iterator().next()).name; 
    return null;
  }
  
  public void defineNamedAction(GrammarAST ampersandAST, GrammarAST nameAST, GrammarAST actionAST) {
    String actionName = nameAST.getText();
    GrammarAST a = (GrammarAST)this.actions.get(actionName);
    if (a != null) {
      ErrorManager.grammarError(144, this.grammar, nameAST.getToken(), nameAST.getText());
    } else {
      this.actions.put(actionName, actionAST);
    } 
  }
  
  public void trackInlineAction(GrammarAST actionAST) {
    this.inlineActions.add(actionAST);
  }
  
  public Map<String, Object> getActions() {
    return this.actions;
  }
  
  public void setActions(Map<String, Object> actions) {
    this.actions = actions;
  }
  
  public String setOption(String key, Object value, Token optionsStartToken) {
    if (!legalOptions.contains(key)) {
      ErrorManager.grammarError(133, this.grammar, optionsStartToken, key);
      return null;
    } 
    if (this.options == null)
      this.options = new HashMap<String, Object>(); 
    if (key.equals("memoize") && value.toString().equals("true"))
      (this.grammar.composite.getRootGrammar()).atLeastOneRuleMemoizes = true; 
    if (key.equals("backtrack") && value.toString().equals("true"))
      (this.grammar.composite.getRootGrammar()).atLeastOneBacktrackOption = true; 
    if (key.equals("k"))
      this.grammar.numberOfManualLookaheadOptions++; 
    this.options.put(key, value);
    return key;
  }
  
  public void setOptions(Map<String, Object> options, Token optionsStartToken) {
    if (options == null) {
      this.options = null;
      return;
    } 
    Set<String> keys = options.keySet();
    for (Iterator<String> it = keys.iterator(); it.hasNext(); ) {
      String optionName = it.next();
      Object optionValue = options.get(optionName);
      String stored = setOption(optionName, optionValue, optionsStartToken);
      if (stored == null)
        it.remove(); 
    } 
  }
  
  public String toString() {
    return "[" + this.grammar.name + "." + this.name + ",index=" + this.index + ",line=" + this.tree.getToken().getLine() + "]";
  }
}
